/*
The following code is

© Andreas Amann, 2009-2011
http://andreasamann.com/

You may incorporate this code into your program(s) without restriction.
This code has been provided "AS IS" and the responsibility for its operation is yours.
You are not permitted to redistribute this code under my name after having made changes.
If you're going to redistribute the code, please make it clear that the code was descended
from my code, but that you've made changes.

NOTE: Please do not reuse the included GV_ConnectPlugIn without my explicit written consent.
*/

var GV_prefs = {
	currentView: null,
	ringPhone: null,
	phoneNumbers: null,
	userName: null,
	billingCredit: null,
	DoubleClickClearsSMSText: null,
	ClearSMSTextAfterSending: null,
	growlUpdateFrequency: null,
	lastReload: null,
	contactsSource: null,
	contactReloadInterval: null
};

var GV_Timers = {
	callCancel: null,
	contactReload: null,
	localTimeUpdate: null,
	hideHelp: null,
	reloadInbox: null
};

function load()
{
	dashcode.setupParts();
	$("textfield_AccountPassword").type = "password";
	$("Version").innerHTML = WC_.getKeyValue("CFBundleGetInfoString").replace("\n","/" + GV_ConnectPlugIn.bundleVersion() +"<br />");
	loadPrefs();
	if (!window.GV_ConnectPlugIn)
	{
		setStatus("Failed to load plugin",true);
		return;
	}
	$("viewstack_front").object.setCurrentViewWithTransition(GV_prefs.userName && GV_prefs.currentView ? GV_prefs.currentView.replace(/img/,"view") : "view_Account",new Transition(Transition.NONE_TYPE),false,false);
	switchView(GV_prefs.userName && GV_prefs.currentView ? GV_prefs.currentView : "img_Account");
	if (!GV_prefs.userName)
	{
		$s("img_Call").cssText = "opacity:.5;";
		$s("img_SMS").cssText = "opacity:.5;";
	}
	else
	{
		setStatus("Logging into account…");
		GV_ConnectPlugIn.login(GV_prefs.userName,null,false,WC_.getPref("lastNotification-" + GV_prefs.userName,0));
	}
	if (!GV_ConnectPlugIn.growlInstalled())
	{
		$s("popup_Interval").visibility = "hidden";
		$("checkbox_Growl").disabled = true;
		$("checkbox_Growl").checked = false;
		$("lbl_UpdateInterval").innerText = "(Growl not installed)";
	}
	else
	{
		if (GV_prefs.growlUpdateFrequency > 0)
		{
			$("checkbox_Growl").checked = true;
			$("popup_Interval").selectedIndex = GV_prefs.growlUpdateFrequency - 1;
		}
		else
		{
			$("checkbox_Growl").checked = false;
			$("popup_Interval").selectedIndex = -GV_prefs.growlUpdateFrequency - 1;
		}
	}
	$("popup_Contacts").selectedIndex = GV_prefs.contactsSource;
}

function remove()
{
	hide();
	stopGrowlUpdates();
	WC_.setInstancePref("ringPhone", null);
	WC_.setInstancePref("userName", null);
	WC_.setInstancePref("currentView", null);
	WC_.getInstancePref("growlUpdateFrequency",null);
}

function hide()
{
	if (GV_Timers.callCancel)
	{
		clearTimeout(GV_Timers.callCancel);
		GV_Timers.callCancel = null;
		stopCallCancel();
	}
	if (GV_Timers.contactReload)
	{
		clearTimeout(GV_Timers.contactReload);
		GV_Timers.contactReload = null;
	}
	if (GV_Timers.localTimeUpdate)
	{
		clearTimeout(GV_Timers.localTimeUpdate);
		GV_Timers.localTimeUpdate = null;
	}
	if (GV_Timers.hideHelp)
	{
		clearTimeout(GV_Timers.hideHelp);
		GV_Timers.hideHelp = null;
		hideHelp();
	}
	if (window.GV_ConnectPlugIn)
		GV_ConnectPlugIn.abortRequests();
	emptySearchResults();
}

function show()
{
	GV_ConnectPlugIn.setLogging(WC_.getPref("PluginLogEnabled",false));
	GV_prefs.DoubleClickClearsSMSText = WC_.getPref("DoubleClickClearsSMSText",true);
	GV_prefs.ClearSMSTextAfterSending = WC_.getPref("ClearSMSTextAfterSending",false);
	if (GV_prefs.phoneNumbers)
		reloadContacts();
	if (($("viewstack_front").object.getCurrentView().id == "view_Call")
		&& $("textfield_NumberCall").value.length)
		calculateLocalTime();
}

function showBack(event)
{
	var front = $("front");
	var back = $("back");

	if (window.widget) {
		widget.prepareForTransition("ToBack");
	}

	front.style.display = "none";
	back.style.display = "block";

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
}

function showFront(event)
{
	var front = $("front");
	var back = $("back");

	if (window.widget) {
		widget.prepareForTransition("ToFront");
	}

	front.style.display="block";
	back.style.display="none";

	if (window.widget) {
		setTimeout('widget.performTransition();', 0);
	}
	
	WC_.setInstancePref("growlUpdateFrequency", GV_prefs.growlUpdateFrequency);
	if (GV_prefs.contactsSource != $("popup_Contacts").selectedIndex)
	{
		GV_prefs.contactsSource = $("popup_Contacts").selectedIndex;
		GV_ConnectPlugIn.setContactsSource(GV_prefs.contactsSource);
		WC_.setInstancePref("contactsSource", GV_prefs.contactsSource);
		GV_prefs.lastReload = 0;
		if (GV_prefs.userName)
			reloadContacts();
	}
	startGrowlUpdates();
	setFocus();
}

if (window.widget) {
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}

function setFocus()
{
	// NOTE: if we call focus() without the timeout we will sometimes lose the focus ring even though the correct field is highlighted
	if ($("viewstack_front").object.getCurrentView().id == "view_Call")
		setTimeout("$('textfield_NumberCall').focus();",100);
	else if ($("viewstack_front").object.getCurrentView().id == "view_SMS")
		setTimeout("$('textfield_NumberSMS').focus();",100);
	else if ($("viewstack_front").object.getCurrentView().id == "view_Account"
		&& !GV_prefs.userName)
		setTimeout("$('textfield_AccountUser').focus();",100);
}

function startGrowlUpdates()
{
	stopGrowlUpdates();
	if (GV_ConnectPlugIn.growlInstalled()
		&& GV_prefs.userName
		&& GV_prefs.growlUpdateFrequency > 0)
		GV_Timers.reloadInbox = setInterval('GV_ConnectPlugIn.reload("Inbox");', 60000 * $("popup_Interval")[GV_prefs.growlUpdateFrequency-1].id);
}

function stopGrowlUpdates()
{
	if (GV_Timers.reloadInbox)
	{
		clearInterval(GV_Timers.reloadInbox);
		GV_Timers.reloadInbox = null;
	}
}

function loadPrefs()
{
	GV_prefs.currentView = WC_.getInstancePref("currentView");
	GV_prefs.ringPhone = WC_.getInstancePref("ringPhone");
	GV_prefs.userName = WC_.getInstancePref("userName");
	GV_prefs.growlUpdateFrequency = WC_.getInstancePref("growlUpdateFrequency",1);
	GV_prefs.contactsSource = WC_.getInstancePref("contactsSource",2);
	GV_ConnectPlugIn.setContactsSource(GV_prefs.contactsSource);
}

function toggleGrowl(event)
{
	$("popup_Interval").disabled = !$("checkbox_Growl").checked;
	GV_prefs.growlUpdateFrequency = ($("checkbox_Growl").checked ? 1 : -1) * ($("popup_Interval").selectedIndex + 1);
}

function changeView(event)
{
	if (GV_prefs.phoneNumbers)
		switchView(event.srcElement.id);
}

function switchView(targetView)
{
	var newView;
	var switchBackwards;
	var currentView = $("viewstack_front").object.getCurrentView().id;
	var focusField;

	if ($s("lbl_Help").visibility == "visible")
		hideHelp();
	
	for (var i = 0; i < 3; i++)
	{
		var eachElement = ["img_Call","img_SMS","img_Account"][i];
		$s(eachElement).cssText = (targetView == eachElement) ? "-webkit-box-shadow: #FFF 0px 0px 6px;border: none;" : "";
	}

	switch (targetView)
	{
		case "img_Call":
			newView = "view_Call";
			switchBackwards = true;
			logoTitle = "Place Call";
			focusField = $("textfield_NumberCall");
			break;
		case "img_SMS":
			newView = "view_SMS";
			switchBackwards = currentView == "view_Account";
			logoTitle = "Send Message";
			if (currentView != newView)
				$("textarea_SMS").disabled = false;
			focusField = $("textfield_NumberSMS");
			break;
		case "img_Account":
			newView = "view_Account";
			switchBackwards = false;
			var logoTitle = "";
			focusField = GV_prefs.userName ? null: $("textfield_AccountUser");
			if (GV_prefs.userName)
			{
				$("textfield_AccountUser").value = GV_prefs.userName;
				$("textfield_AccountPassword").value = lookupPassword();
				$("lbl_GVNumber").innerText = GV_ConnectPlugIn.GVAccountInfo()[0] || "";
				$s("lbl_GVNumber").visibility = GV_ConnectPlugIn.GVAccountInfo()[0] ? "visible" : "hidden";
				$("btn_Login").object.textElement.innerText = "Logout";
				$("btn_Login").object.onclick = doLogout;
			}
			break;
	}
	if (newView != currentView)
	{
		emptySearchResults();
		stopCallCancel();
		if (newView == "view_SMS")
			updateRemaningCharCount();
		else
			$("lbl_SMSCountCredit").innerText = GV_prefs.billingCredit;
		$s("img_ClearSearch").visibility = focusField && focusField.value.length ? "visible" : "hidden";
		$("viewstack_front").object.setCurrentViewWithTransition(newView,new Transition(Transition.NONE_TYPE),switchBackwards,false);
		GV_prefs.currentView = newView;
		WC_.setInstancePref("currentView", targetView);
		if (newView == "view_Account" && GV_prefs.phoneNumbers && GV_prefs.phoneNumbers.length)
			$("scrollArea_forwarding").object.refresh();
	}
	$("img_Logo").title = logoTitle;
	if (focusField)
	{
		focusField.disabled = false;
		focusField.focus();
	}
	if (newView == "view_Call")
	{
		if ($("textfield_NumberCall").value.length)
			calculateLocalTime();
	}
	else
	{
		if (GV_Timers.localTimeUpdate)
		{
			clearTimeout(GV_Timers.localTimeUpdate);
			GV_Timers.localTimeUpdate = null;
		}
	}
}

function setStatus(status,critical,tag)
{
	critical = critical || false;
	$("lbl_Status").innerText = status;
	$s("lbl_Status").backgroundColor = critical ? "rgba(255,0,0,.9)" : "rgba(0,0,0,0)";
	$("lbl_Status").tag = tag;
	$s("lbl_SMSCountCredit").visibility = status.length ? "hidden" : "visible";
	$s("lbl_SMSCountCredit").zIndex = status.length ? 0 : 20;
}

function setDND(status)
{
	$("checkbox_DND").checked = status;
}

function statusClicked(event) {
	if (!$("lbl_Status").tag)
	{
		setStatus("");
		return;
	}
	switch ($("lbl_Status").tag)
	{
		case "LOGIN":
			doLogin();
			break;
		case "LOGOUT":
			doLogout();
			break;
		case "ACCOUNTINFO":
			reloadContacts();
			break;
		case "CALL":
		case "CALLCANCEL":
		case "SMS":
			placeCall();
			break;
		default:
			if (GV_prefs.phoneNumbers)
				reloadContacts();
			else
				doLogin();
			break;
	}
	$("lbl_Status").tag = null;
}

function hideHelp() {
	if (GV_Timers.hideHelp)
	{
		clearTimeout(GV_Timers.hideHelp);
		GV_Timers.hideHelp = null;
	}
	var helpAnimator = new AppleAnimator(500, 13);
	var helpAnimation = new AppleAnimation(1.0, 0.0, fadeHelp);
	helpAnimator.addAnimation(helpAnimation);
	helpAnimator.oncomplete = function() {$s("lbl_Help").cssText = "";};
	helpAnimator.start();
}

function fadeHelp(currentAnimator, current, start, finish) {
	$s("lbl_Help").opacity = current;
}

function reloadContacts()
{
	GV_prefs.contactReloadInterval = 1000 * WC_.getPref("contactReloadInterval",300);
	if (GV_prefs.contactReloadInterval <= 0
		|| (GV_prefs.lastReload && ((new Date().getTime() - GV_prefs.lastReload) < GV_prefs.contactReloadInterval)))
		return;	// don't reload our contacts if we just did it less then 5 minutes ago…
	if (GV_Timers.contactReload)
	{
		clearTimeout(GV_Timers.contactReload);
		GV_Timers.contactReload = null;
	}
	setStatus("Refreshing contact list…");
	GV_ConnectPlugIn.reload("Contacts");
}

function finishedLoadingContacts()
{
	setStatus("");
	GV_prefs.lastReload = new Date().getTime();
	if (GV_Timers.contactReload)
	{
		clearTimeout(GV_Timers.contactReload);
		GV_Timers.contactReload = null;
	}
	if (GV_prefs.contactReloadInterval > 0)
		GV_Timers.contactReload = setTimeout("reloadContacts();",3 * GV_prefs.contactReloadInterval); // reload after 15min if the Dashboard stays open that long
}

function forwardingNumbersReceived()
{
	accountInfoReceived(true);	// make sure we hide previous failed login attempts
	GV_prefs.phoneNumbers = GV_ConnectPlugIn.phoneNumbers();
	var popupValues = [];
	for (var i = 0; i < GV_prefs.phoneNumbers.length; i++)
		popupValues.push(WC_.html_decode(GV_prefs.phoneNumbers[i][0]));
	$("popup_RingPhone").object.setOptions(popupValues,false);
	GV_prefs.ringPhone = GV_prefs.ringPhone || 0;
	$("popup_RingPhone").object.setSelectedIndex(GV_prefs.ringPhone);
	$s("lbl_NumberCall").visibility = "visible";
	$s("textfield_NumberCall").visibility = "visible";
	if (!datasource_SearchMatch.numberOfRows())
	{
		$s("lbl_RingPhone").visibility = GV_prefs.phoneNumbers.length > 1 ? "visible" : "hidden";
		$s("popup_RingPhone").visibility = GV_prefs.phoneNumbers.length > 1 ? "visible" : "hidden";
	}
	$s("lbl_LoadingAccount").visibility = "";
	$s("checkboxGroup_DND").visibility = "visible";
	$("checkbox_DND").checked = GV_ConnectPlugIn.GVAccountInfo()[1];
	datasource_Forwarding.setRowData(GV_prefs.phoneNumbers);
	$("scrollArea_forwarding").object.refresh();
	$s("lbl_Forwarding").visibility = "visible";
	$s("scrollArea_forwarding").visibility = "visible";
}

function accountInfoReceived(success)
{
	$s("textfield_AccountPassword").visibility = success ? "hidden" : "";
	$s("lbl_AccountPassword").visibility = success ? "hidden" : "";
	$("textfield_AccountPassword").disabled = false;
	$("textfield_AccountUser").disabled = false;
	$s("textfield_AccountUser").visibility = success ? "hidden" : "";
	$s("lbl_AccountUser").visibility = success ? "hidden" : "";
	if (success)
	{
		setStatus("");
		$s("lbl_LoadingAccount").visibility = "visible";
		$s("checkboxGroup_DND").visibility = "";
		$s("lbl_Forwarding").visibility = "";
		$s("scrollArea_forwarding").visibility = "";
		$("btn_Login").object.textElement.innerText = "Logout";
		$("btn_Login").object.onclick = doLogout;
		$s("img_Call").opacity = 1;
		$s("img_SMS").opacity = 1;
		$("lbl_GVNumber").innerText = GV_ConnectPlugIn.GVAccountInfo()[0] || "";
		$s("lbl_GVNumber").visibility = GV_ConnectPlugIn.GVAccountInfo()[0] ? "visible" : "hidden";
		if (!WC_.getPref("ViewIconsHelp",false))
		{
			$("lbl_Help").innerText = "Change views using small icons";
			$s("lbl_Help").cssText = "opacity:0;visibility:visible;top:90px;";
			var helpAnimator = new AppleAnimator(500, 13);
			var helpAnimation = new AppleAnimation(0.0, 1.0, fadeHelp);
			helpAnimator.addAnimation(helpAnimation);
			helpAnimator.start();
			WC_.setPref("ViewIconsHelp", true);
			GV_Timers.hideHelp = setTimeout("hideHelp();",5000);
		}
		startGrowlUpdates();
	}
	else
	{
		setStatus("Login failed - check password",true);
		$s("lbl_LoadingAccount").visibility = "";
		$s("checkboxGroup_DND").visibility = "";
		$s("lbl_Forwarding").visibility = "";
		$s("scrollArea_forwarding").visibility = "";
		$("btn_Login").object.textElement.innerText = "Login";
		$("btn_Login").object.onclick = doLogin;
		$s("img_Call").cssText = "opacity:.5;";
		$s("img_SMS").cssText = "opacity:.5;";
		switchView("img_Account");
		$("textfield_AccountPassword").focus();
	}

}

function setClipboard(text) {
	GV_ConnectPlugIn.setClipboard(text);
}

function GVNumberClicked(event) {
	if (event.ctrlKey)
		setClipboard(event.srcElement.innerText);
	else
		widget.openURL('https://www.google.com/voice/#phones');
}

function callStarted(success) {
	if (!success)
	{
		stopCallCancel();
		setStatus("Failed to start call", true);
	}
	else
		GV_Timers.callCancel = setTimeout("stopCallCancel();",30000);
}

function messageSent(success) {
	$("textfield_NumberSMS").disabled = false;
	$("textarea_SMS").disabled = false;
	if (GV_prefs.ClearSMSTextAfterSending)
		$("textarea_SMS").value = "";
	if ($("viewstack_front").object.getCurrentView().id == "view_SMS")
		$("textfield_NumberSMS").focus();
	$("SMSBezel").innerText = "";
	$s("SMSBezel").visibility = "";
	setStatus(success ? "" : "Failed to send SMS", !success);
}

function stopCallCancel() {
	if (GV_Timers.callCancel)
	{
		clearTimeout(GV_Timers.callCancel);
		GV_Timers.callCancel = null;
	}
	$("textfield_NumberCall").disabled = false;
	if ($("viewstack_front").object.getCurrentView().id == "view_Call")
	{
		$("textfield_NumberCall").focus();
		$("img_Logo").title = "Place Call";
	}
	$("img_Logo").src = "Images/GV_Logo.png";
	setStatus("");
}

var datasource_SearchMatch = {
	_rowData: [],
	_selectedRow: -1,

	setRowData: function(newValues) {
		this._selectedRow = -1;
		this._rowData = newValues;
		$("list").object.reloadData();
	},
	
	numberOfRows: function() {
		return this._rowData ? this._rowData.length : 0;
	},

	prepareRow: function(rowElement, rowIndex, templateElements)
	{
		rowElement.style.backgroundColor = rowIndex % 2 ? "#c8c9fd" : "";
		rowElement.style.backgroundImage = "-webkit-gradient(linear,left top,left bottom,from(#fff),to(#d9dafe),color-stop(0.3,#fff))";
		templateElements.label.innerHTML = this._rowData[rowIndex][0] + " (" + this._rowData[rowIndex][2] + ") " + this._rowData[rowIndex][1];
		templateElements.icon.src = this._rowData[rowIndex][3] ? "Images/GoogleContact.png" : "Images/AddressBook.png";
		rowElement.title = templateElements.label.innerText;

		rowElement.onclick = function(event)
		{
			if ($("viewstack_front").object.getCurrentView().id == "view_Call")
			{
				$("textfield_NumberCall").focus();
				$("textfield_NumberCall").value = datasource_SearchMatch._rowData[rowIndex][1].replace(/<.*?>/g,"");
				$("textfield_NumberCall").title = datasource_SearchMatch._rowData[rowIndex][0].replace(/<.*?>/g,"") + " (" + datasource_SearchMatch._rowData[rowIndex][2] + ")";
				calculateLocalTime();
			}
			else
			{
				$("textfield_NumberSMS").focus();
				if ($("textfield_NumberSMS").value.match(/,/))
				{
					$("textfield_NumberSMS").value = $("textfield_NumberSMS").value.replace(/(.*),.*/,"$1, ") + datasource_SearchMatch._rowData[rowIndex][1].replace(/<.*?>/g,"");
					$("textfield_NumberSMS").title += "\n" + datasource_SearchMatch._rowData[rowIndex][0].replace(/<.*?>/g,"") + " (" + datasource_SearchMatch._rowData[rowIndex][2] + ")";
				}
				else
				{
					$("textfield_NumberSMS").value = datasource_SearchMatch._rowData[rowIndex][1].replace(/<.*?>/g,"");
					$("textfield_NumberSMS").title = datasource_SearchMatch._rowData[rowIndex][0].replace(/<.*?>/g,"") + " (" + datasource_SearchMatch._rowData[rowIndex][2] + ")";
				}
				$("textfield_NumberSMS").scrollLeft = Math.max($("textfield_NumberSMS").scrollWidth - $("textfield_NumberSMS").offsetWidth + 18, 0);
			}
			$s("scrollArea_popup").zIndex = 0;
			$s("list").zIndex = 0;
			emptySearchResults();
		};
	}
};

var datasource_Forwarding = {
	_rowData: [],

	setRowData: function(newValues) {
		this._rowData = newValues;
		$("list1").object.reloadData();
	},
	
	numberOfRows: function() {
		return this._rowData ? this._rowData.length : 0;
	},

	prepareRow: function(rowElement, rowIndex, templateElements)
	{
		templateElements.forwardingLabel.innerHTML = this._rowData[rowIndex][0];
		templateElements.checkbox_forwarding.checked = this._rowData[rowIndex][3];
		rowElement.title = this._rowData[rowIndex][4];

		rowElement.onclick = function(event)
		{
			if (event.ctrlKey)
				setClipboard(GV_prefs.phoneNumbers[rowIndex][4]);
			else
			{
				GV_ConnectPlugIn.enableForwardingForNumber(GV_prefs.phoneNumbers[rowIndex][2],!GV_prefs.phoneNumbers[rowIndex][3]);
				// for some reason we can't just change GV_prefs.phoneNumbers[rowIndex][3] directly or use splice() - rebuild our data source
				var tmp = [];
				for (i = 0; i < datasource_Forwarding.numberOfRows(); i++)
				{
					if (i == rowIndex)
						tmp.push([GV_prefs.phoneNumbers[rowIndex][0],GV_prefs.phoneNumbers[rowIndex][1],GV_prefs.phoneNumbers[rowIndex][2],!GV_prefs.phoneNumbers[rowIndex][3],GV_prefs.phoneNumbers[rowIndex][4]]);
					else
						tmp.push(GV_prefs.phoneNumbers[i]);
				}
				GV_prefs.phoneNumbers = tmp;
				datasource_Forwarding.setRowData(GV_prefs.phoneNumbers);
			}
			// make sure we update the state of the checkbox even after clicking on the label (or clicking the checkbox while holding down the Ctrl key)
			$("list1").object.reloadData();
		};
	}
};

function updateSearchResults(event)
{
	var textField = event.srcElement;
	var searchList = $("list").object;
	$s("img_ClearSearch").visibility = textField.value.length ? "visible" : "hidden";
	if (event.keyIdentifier == "Down"
		&& datasource_SearchMatch.numberOfRows())
	{
		if (datasource_SearchMatch._selectedRow + 1 < datasource_SearchMatch.numberOfRows())
			datasource_SearchMatch._selectedRow++;
		if (datasource_SearchMatch._selectedRow >= 0)
			searchList.setSelectionIndexes([datasource_SearchMatch._selectedRow],false);
		if (datasource_SearchMatch._selectedRow > 2)
			searchList.element.parentElement.parentElement.object.reveal(searchList.rows[datasource_SearchMatch._selectedRow - 2]);
		else if (datasource_SearchMatch._selectedRow == 0)
			searchList.element.parentElement.parentElement.object.reveal(searchList.rows[0]);
	}
	else if (event.keyIdentifier == "Up"
		&& datasource_SearchMatch.numberOfRows())
	{
		if (datasource_SearchMatch._selectedRow >= 0)
			datasource_SearchMatch._selectedRow--;
		if (datasource_SearchMatch._selectedRow >= 0)
			searchList.setSelectionIndexes([datasource_SearchMatch._selectedRow],false);
		if (datasource_SearchMatch._selectedRow > 0)
			searchList.element.parentElement.parentElement.object.reveal(searchList.rows[datasource_SearchMatch._selectedRow - 1]);
	}
	else if (event.keyIdentifier == "Enter"
		&& datasource_SearchMatch.numberOfRows())
	{
		if (datasource_SearchMatch._selectedRow >= 0)
			searchList.rows[datasource_SearchMatch._selectedRow].object.clickHandler();
		else
			emptySearchResults();
	}
	else if (event.keyIdentifier == "Enter"
		&& !datasource_SearchMatch.numberOfRows())
		placeCall();
	else
	{
		setStatus("");
		if (textField.value.length
			&& !textField.value.match(/^[ +]+$/))
		{
			if (textField.id == "textfield_NumberSMS")
			{
				if (textField.value.match(/,/g) && textField.value.match(/,/g).length > 4)
				{
					emptySearchResults();
					setStatus("Maximum number of recipients exceeded",true);
				}
				else
					datasource_SearchMatch.setRowData(GV_ConnectPlugIn.contactsWithString(textField.value.replace(/.*, */,""),true));
			}
			else
				datasource_SearchMatch.setRowData(GV_ConnectPlugIn.contactsWithString(textField.value,false));
		}
		else
			emptySearchResults();
		if (textField.id == "textfield_NumberCall")
			$("lbl_LocationTime").innerText = "";
		if (datasource_SearchMatch.numberOfRows())
			searchList.element.parentElement.parentElement.object.reveal(searchList.rows[0]);
	}
	if (textField.id == "textfield_NumberCall"
		&& !datasource_SearchMatch.numberOfRows())
			calculateLocalTime();
	if (datasource_SearchMatch.numberOfRows())
		if (textField.id == "textfield_NumberSMS" && !textField.value.match(/,/))
			textField.title = "";
	$s("scrollArea_popup").zIndex = datasource_SearchMatch.numberOfRows() ? 20 : 0;
	$s("list").zIndex = datasource_SearchMatch.numberOfRows() ? 20 : 0;
	if (textField.value.length
		&& !datasource_SearchMatch.numberOfRows()
		&& !WC_.getPref("CallIconHelp", false))
	{
		$("lbl_Help").innerText = (textField.id == "textfield_NumberCall") ? "Click icon to start call" : "Click icon to send message";
		$s("lbl_Help").cssText = "opacity:0;visibility:visible;";
		var helpAnimator = new AppleAnimator(500, 13);
		var helpAnimation = new AppleAnimation(0.0, 1.0, fadeHelp);
		helpAnimator.addAnimation(helpAnimation);
		helpAnimator.start();
		WC_.setPref("CallIconHelp", true);
		GV_Timers.hideHelp = setTimeout("hideHelp();",5000);
	}
}

function emptySearchResults() {
	datasource_SearchMatch.setRowData([]);
}

function updateCredit(credit)
{
	GV_prefs.billingCredit = credit || "";
	if ($("viewstack_front").object.getCurrentView().id != "view_SMS")
		$("lbl_SMSCountCredit").innerText = GV_prefs.billingCredit;
	else
		updateRemaningCharCount();
}

function updateRemaningCharCount(event)
{
	// make sure we show the scrollbar if necessary
	$("textarea_SMS").parentElement.object.refresh();
	$("lbl_SMSCountCredit").innerText = 160 - $("textarea_SMS").value.length;
	setStatus(160 - $("textarea_SMS").value.length < 0 ? ("Maximum message length exceeded by " + ($("textarea_SMS").value.length - 160) + " chars") : "",160 - $("textarea_SMS").value.length < 0);
}


function clearSearchField(event)
{
	var isCallView = $("viewstack_front").object.getCurrentView().id == "view_Call";
	var textField = $(isCallView ? "textfield_NumberCall" : "textfield_NumberSMS");
	var searchList = $("list").object;
	textField.value = "";
	textField.title = "";
	emptySearchResults();
	$s("scrollArea_popup").zIndex = datasource_SearchMatch.numberOfRows() ? 20 : 0;
	$s("list").zIndex = datasource_SearchMatch.numberOfRows() ? 20 : 0;
	if (isCallView)
		$("lbl_LocationTime").innerText = "";
	$s("img_ClearSearch").visibility = "hidden";
	textField.focus();
}

function calculateLocalTime(event)
{
	if (GV_Timers.localTimeUpdate)
	{
		clearTimeout(GV_Timers.localTimeUpdate);
		GV_Timers.localTimeUpdate = null;
	}
	var timeInformation = GV_ConnectPlugIn.localTimeForNumber($("textfield_NumberCall").value);
	$("lbl_LocationTime").innerHTML = timeInformation[0].replace(/NW Terr./,"NWT").replace(/Prince Edward Island/,"PEI") + "<br>" + timeInformation[1];
	if (timeInformation[0].length || timeInformation[1].length)
		GV_Timers.localTimeUpdate = setTimeout("calculateLocalTime();",1000 * (60 - new Date().getSeconds()));
}

function replaceLettersForPhone(phoneNumber)
{
	return phoneNumber.replace(/[abc]/ig,"2").replace(/[def]/ig,"3").replace(/[ghi]/ig,"4").replace(/[jkl]/ig,"5").replace(/[mno]/ig,"6").replace(/[pqrs]/ig,"7").replace(/[tuv]/ig,"8").replace(/[wxyz]/ig,"9");
}

function placeCall(event)
{
	if ($("viewstack_front").object.getCurrentView().id == "view_Call")
	{
		if ($("img_Logo").src.match("Images/GV_Logo_red.png"))
		{
			if (GV_Timers.callCancel)
			{
				clearTimeout(GV_Timers.callCancel);
				GV_Timers.callCancel = null;
			}
			$("img_Logo").src = "Images/GV_Logo.png";
			$("img_Logo").title = "Place Call";
			setStatus("Cancelling call…");
			$("textfield_NumberCall").disabled = false;
			$("textfield_NumberCall").focus();
			GV_ConnectPlugIn.cancelCall();
		}
		else
		{
			if ($("textfield_NumberCall").value.length >= 7)
			{
				$("img_Logo").src = "Images/GV_Logo_red.png";
				$("img_Logo").title = "Cancel Call";
				$("textfield_NumberCall").blur();
				$("textfield_NumberCall").disabled = true;
				setStatus("Calling you - click icon to cancel…");
				GV_ConnectPlugIn.placeCall(replaceLettersForPhone($("textfield_NumberCall").value), GV_prefs.phoneNumbers[GV_prefs.ringPhone][2]);
			}
		}
	}
	else if ($("viewstack_front").object.getCurrentView().id == "view_SMS")
	{
		if ($("textfield_NumberSMS").value.length >= 7
			 && $("textarea_SMS").value.length
			 && $("textarea_SMS").value.length <= 160)
		{
			$("SMSBezel").innerText = "Sending message…";
			$s("SMSBezel").visibility = "visible";
			$("textfield_NumberSMS").blur();
			$("textfield_NumberSMS").disabled = true;
			$("textarea_SMS").blur();
			$("textarea_SMS").disabled = true;
			GV_ConnectPlugIn.sendSMS(replaceLettersForPhone($("textfield_NumberSMS").value), $("textarea_SMS").value);
		}
	}
}

function changeRingBack(event)
{
	GV_prefs.ringPhone = event.srcElement.selectedIndex;
	WC_.setInstancePref("ringPhone", GV_prefs.ringPhone);
	$("textfield_NumberCall").focus();
}

function openBillingPage(event)
{
	if ($("viewstack_front").object.getCurrentView().id != "view_SMS")
		widget.openURL('https://www.google.com/voice/#billing');
}

function doLogin(event)
{
	if ($("textfield_AccountUser").value.length
		&& $("textfield_AccountPassword").value.length)
	{
		setStatus("Logging into account…");
		GV_prefs.userName = $("textfield_AccountUser").value
		WC_.setInstancePref("userName", GV_prefs.userName);
		GV_ConnectPlugIn.login(GV_prefs.userName,$("textfield_AccountPassword").value,true,WC_.getPref("lastNotification-" + GV_prefs.userName,""));
		$("textfield_AccountPassword").disabled = true;
		$("textfield_AccountUser").disabled = true;
		$("textfield_AccountPassword").blur();
		$("textfield_AccountUser").blur();
	}
}

function doLogout(event)
{
	stopGrowlUpdates();
	$s("lbl_Forwarding").visibility = "";
	$s("scrollArea_forwarding").visibility = "";
	$s("checkboxGroup_DND").visibility = "";
	$("textfield_AccountPassword").value = "";
	$("textfield_AccountUser").value = "";
	$("textfield_AccountPassword").disabled = false;
	$("textfield_AccountUser").disabled = false;
	$s("textfield_AccountPassword").visibility = "";
	$s("lbl_AccountPassword").visibility = "";
	$s("textfield_AccountUser").visibility = "";
	$s("lbl_AccountUser").visibility = "";
	$("textfield_AccountUser").focus();
	$("lbl_GVNumber").innerText = "";
	$s("lbl_GVNumber").visibility = "hidden";
	GV_ConnectPlugIn.logout();
	GV_prefs.userName = null;
	WC_.setInstancePref("userName", null);
	GV_prefs.phoneNumbers = null;
	updateCredit();
	$("btn_Login").object.textElement.innerText = "Login";
	$("btn_Login").object.onclick = doLogin;
	$s("img_Call").cssText = "opacity:.5;";
	$s("img_SMS").cssText = "opacity:.5;";
}


function lookupPassword(event)
{
	$("textfield_AccountPassword").value = GV_ConnectPlugIn.getKeychainPasswordForUser($("textfield_AccountUser").value) || "";
}


function changeFocus(event)
{
    if (event.srcElement.id == "textfield_AccountUser")
	{
		if (event.keyIdentifier == "Enter")
		{
			lookupPassword();
			$("textfield_AccountPassword").focus();
		}
	}
	else if (event.srcElement.id == "textfield_AccountPassword")
	{
		if (event.keyIdentifier == "Enter")
			doLogin();
	}
}

function displayUnreadCount(newCount)
{
	newCount = parseInt(newCount,10) > 99 ? "…" : newCount;
	$("lbl_UnreadCount").innerText = newCount;
	$s("lbl_UnreadCount").cssText = newCount ? "visibility:visible;" : "";
	$s("shape_UnreadCount").cssText = newCount ? "visibility:visible;" : "";
}

function sendFeedback(event)
{
	widget.openURL("mailto:Andreas Amann <aamann@mac.com>?subject=GV Connect " + WC_.getKeyValue("CFBundleShortVersionString"));
}

function replySMS(phoneNumber,contactName)
{
	$("viewstack_front").object.setCurrentViewWithTransition("view_SMS",new Transition(Transition.NONE_TYPE),false,false);
	switchView("img_SMS");
	$("textfield_NumberSMS").value = phoneNumber;
	$("textfield_NumberSMS").title = contactName;
	$s("img_ClearSearch").visibility = phoneNumber.length ? "visible" : "hidden";
	updateRemaningCharCount();
	$("textarea_SMS").focus();
}

function writeLastNotificationTime(data) {
	WC_.setPref("lastNotification-" + GV_prefs.userName, data);
}